Description

In the API doc, it says you can either use a root node or not. However, this only works with JSON. As in 

http://projects.theforeman.org/issues/5178, many (or maybe most) API users aren't using JSON.

Related issues:

Related to Foreman - Bug #6786: Cannot create an organization. Closed 07/26/2014

Related to Katello - Bug #8846: Katello API throws an incorrect error when re... Closed 01/06/2015

Associated revisions

Revision 50ebc024 - 07/31/2014 11:17 AM - David Davis

Fixes #6446 - Forbidding non-json POST/PUT requests in v2

History

#1 - 07/17/2014 04:24 AM - Joseph Magen

our API is only JSON format??

#2 - 07/17/2014 08:23 AM - David Davis

Responded to your email but figured I'd post a copy here too. What do you mean by "our API is only JSON format"? Does that mean that users can't

submit form data to the fortello API? Looks like you can to me:

$ curl -X POST http://localhost:3000/api/v2/organizations -d "organization[name]=Test2345" -u admin:changeme

{"ancestry":null,"apply_info_task_id":null,"created_at":"2014-07-17T12:22:48Z","default_info":{"system":[],"di

stributor":[]},"description":null,"id":7,"ignore_types":[],"katello_default":true,"label":"Test2345","name":"T

est2345","owner_auto_attach_all_systems_task_id":null,"title":"Test2345","updated_at":"2014-07-17T12:22:55Z","

service_levels":[],"service_level":null} 

#3 - 07/17/2014 08:36 AM - David Davis

The problem that I've dealt with a few times over the past month with the API users is that they see that requests like this don't work:

$ curl -X POST http://localhost:3000/api/v2/organizations -d "name=Test2345" -u admin:changeme

 While requests like this do:

$ curl -X POST http://localhost:3000/api/v2/organizations -d "organization[name]=Test2345" -u admin:changeme

 So they get confused and then I get asked questions like "Why does the apidoc say that the params should be un-nested but then I get an error when

I send nested params?" and "Why are some api endpoints nested and others aren't?" Maybe the solution is to show an error that we only accept

JSON? I don't care either way but I feel like we do need to do something though because I've seen this at least 3 times already.

#4 - 07/17/2014 08:54 AM - David Davis

- Subject changed from Consider extending wrap_parameters since a lot of API users aren't using JSON to Since a lot of API users aren't using JSON

to send requests, consider extending wrap_parameters or showing an error when they send other content types like

application/x-www-form-urlencoded
#5 - 07/25/2014 07:27 PM - David Davis

- Subject changed from Since a lot of API users aren't using JSON to send requests, consider extending wrap_parameters or showing an error when

they send other content types like application/x-www-form-urlencoded to We need to either support non-json requests or show an error when a user

submits other content types.

Simplifying title.

By the way, here's another example. QA hits an user-unfriendly error when submitting non-json:

https://bugzilla.redhat.com/show_bug.cgi?id=1116043

#6 - 07/26/2014 12:53 PM - David Davis

- Related to Bug #6786: Cannot create an organization. added

#7 - 07/28/2014 11:56 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Target version set to 1.8.0

- Pull request https://github.com/theforeman/foreman/pull/1622 added

- Pull request deleted ()

#8 - 07/29/2014 03:17 AM - Dominic Cleal

- Assignee set to David Davis

#9 - 07/30/2014 06:50 AM - Anonymous

- Target version changed from 1.8.0 to 1.7.5

#10 - 07/31/2014 10:50 AM - Dominic Cleal

- translation missing: en.field_release set to 10

#11 - 07/31/2014 12:01 PM - David Davis

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 50ebc024bd5b13b490c41f2b3e5e0c489e7f892b.

#12 - 08/13/2014 11:56 AM - Bryan Kearney

- Bugzilla link set to 1129769

#13 - 01/06/2015 02:14 PM - David Davis

- Related to Bug #8846: Katello API throws an incorrect error when receiving non-json requests added
